#include <Windows.h>
#include <TlHelp32.h>
#include <iostream>
#include <string>

DWORD GetProcessIdByName(const std::wstring& processName) {
    PROCESSENTRY32 processInfo;
    processInfo.dwSize = sizeof(processInfo);

    HANDLE processSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);
    if (processSnapshot == INVALID_HANDLE_VALUE) {
        return 0;
    }

    Process32First(processSnapshot, &processInfo);
    do {
        if (!processName.compare(processInfo.szExeFile)) {
            CloseHandle(processSnapshot);
            return processInfo.th32ProcessID;
        }
    } while (Process32Next(processSnapshot, &processInfo));

    CloseHandle(processSnapshot);
    return 0;
}

int main() {
    std::wstring processName = L"vive_mouse.exe";
    std::wstring dllPath = L"InjectUser.dll";

    DWORD processId = GetProcessIdByName(processName);
    if (!processId) {
        std::wcerr << L"Could not find process: " << processName << std::endl;
        return 1;
    }

    HANDLE processHandle = OpenProcess(PROCESS_ALL_ACCESS, FALSE, processId);
    if (!processHandle) {
        std::wcerr << L"Could not open process: " << processName << std::endl;
        return 1;
    }

    void* dllPathAddressInRemoteProcess = VirtualAllocEx(processHandle, NULL, dllPath.size() * sizeof(wchar_t) + 1, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
    if (!dllPathAddressInRemoteProcess) {
        std::wcerr << L"Could not allocate memory in remote process" << std::endl;
        CloseHandle(processHandle);
        return 1;
    }

    if (!WriteProcessMemory(processHandle, dllPathAddressInRemoteProcess, dllPath.c_str(), dllPath.size() * sizeof(wchar_t) + 1, NULL)) {
        std::wcerr << L"Could not write to remote process memory" << std::endl;
        VirtualFreeEx(processHandle, dllPathAddressInRemoteProcess, 0, MEM_RELEASE);
        CloseHandle(processHandle);
        return 1;
    }

    HANDLE remoteThread = CreateRemoteThread(processHandle, NULL, 0, (LPTHREAD_START_ROUTINE)LoadLibraryW, dllPathAddressInRemoteProcess, 0, NULL);
    if (!remoteThread) {
        std::wcerr << L"Could not create remote thread" << std::endl;
        VirtualFreeEx(processHandle, dllPathAddressInRemoteProcess, 0, MEM_RELEASE);
        CloseHandle(processHandle);
        return 1;
    }

    WaitForSingleObject(remoteThread, INFINITE);

    // Clean up
    VirtualFreeEx(processHandle, dllPathAddressInRemoteProcess, 0, MEM_RELEASE);
    CloseHandle(remoteThread);
    CloseHandle(processHandle);

    std::wcout << L"Successfully injected " << dllPath << L" into " << processName << std::endl;
    return 0;
}

