// dllmain.cpp : Defines the entry point for the DLL application.
#include "pch.h"
#include <Windows.h>
#include "detours.h"

// Function prototypes
typedef UINT(WINAPI* SendInput_t)(UINT, LPINPUT, int);
typedef BOOL(WINAPI* SetCursorPos_t)(int, int);

// Original functions
SendInput_t originalSendInput = (SendInput_t)GetProcAddress(GetModuleHandle(TEXT("user32.dll")), "SendInput");
SetCursorPos_t originalSetCursorPos = (SetCursorPos_t)GetProcAddress(GetModuleHandle(TEXT("user32.dll")), "SetCursorPos");

// Hook functions
UINT WINAPI hookedSendInput(UINT cInputs, LPINPUT pInputs, int cbSize) {
    // Do something with the intercepted call, e.g., log the inputs or modify them
    //return originalSendInput(cInputs, pInputs, cbSize);
    return 0;
}

BOOL WINAPI hookedSetCursorPos(int X, int Y) {
    // Do something with the intercepted call, e.g., log the coordinates or modify them
    return originalSetCursorPos(X, Y);
    //return originalSetCursorPos(30, 30);
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved) {
    switch (ul_reason_for_call) {
    case DLL_PROCESS_ATTACH:
        DetourRestoreAfterWith();
        DetourTransactionBegin();
        DetourUpdateThread(GetCurrentThread());
        DetourAttach(&(PVOID&)originalSendInput, hookedSendInput);
        DetourAttach(&(PVOID&)originalSetCursorPos, hookedSetCursorPos);
        DetourTransactionCommit();
        break;
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
        break;
    case DLL_PROCESS_DETACH:
        DetourTransactionBegin();
        DetourUpdateThread(GetCurrentThread());
        DetourDetach(&(PVOID&)originalSendInput, hookedSendInput);
        DetourDetach(&(PVOID&)originalSetCursorPos, hookedSetCursorPos);
        DetourTransactionCommit();
        break;
    }
    return TRUE;
}
